package es.virtualgolf.tools;

import es.virtualgolf.views.SensoresAct;
import android.content.Context;
import android.util.AttributeSet;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.widget.Button;

public class BotonPersonalizado extends Button {    
    
    private SensoresAct main;

    public BotonPersonalizado(Context context, AttributeSet attrs, int defStyle) {
        super(context, attrs, defStyle);
    }

    public BotonPersonalizado(Context context, AttributeSet attrs) {
        super(context, attrs);
    }
    
    public BotonPersonalizado(Context context) {
        super(context);
    }
        
    public void setMain(SensoresAct sl) {
        main = sl;
    }
    
    @Override
    public boolean onTouchEvent(MotionEvent event) {
        cancelLongpressIfRequired(event);
        return super.onTouchEvent(event);
    }
    
    @Override
    public boolean onTrackballEvent(MotionEvent event) {
        cancelLongpressIfRequired(event);
        return super.onTrackballEvent(event);
    }
    
    @Override
    public boolean onKeyUp(int keyCode, KeyEvent event) {
        if ((keyCode == KeyEvent.KEYCODE_DPAD_CENTER) || (keyCode == KeyEvent.KEYCODE_ENTER)) {
            cancelLongpress();
        }
        return super.onKeyUp(keyCode, event);
    }
    
    private void cancelLongpressIfRequired(MotionEvent event) {
        if ((event.getAction() == MotionEvent.ACTION_CANCEL) || (event.getAction() == MotionEvent.ACTION_UP)) {
            cancelLongpress();
        }
    }

    private void cancelLongpress() {
		if (main != null) {
			main.cancelLongPress();
		}
    }
}
