package es.virtualgolf.views;

import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;
import es.ucm.look.ar.LookAR;
import es.ucm.look.ar.util.LookARUtil;
import es.ucm.look.data.EntityData;
import es.ucm.look.data.LookData;
import es.virtualgolf.tools.MyWorldEntityFactory;
import es.virtualgolf.tools.Operaciones;

public class PrincipalAct extends LookAR {
	
	EntityData bola;
	EntityData banderin;
	Integer golpes = 0;
	TextView tv_golpes;

	public PrincipalAct() {
		super(true, true, false, true, 100.0f, true);
	}

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
        //Recuperamos la informacin pasada en el intent
        Bundle bundle = this.getIntent().getExtras();
        addHud();
        Button btn_golpear = (Button) findViewById(R.id.btn_golpear);
        tv_golpes = (TextView) findViewById(R.id.tv_golpes);
        
        //Comienzo del juego
		if(bundle == null){
			
			tv_golpes.setText("Nmero de golpes: " + golpes);
			
			LookData.getInstance().setWorldEntityFactory(new MyWorldEntityFactory());
			
			// Creamos la bola
			bola = new EntityData("bola");
			bola.setLocation(5, 0, 4);
			bola.setPropertyValue(MyWorldEntityFactory.NAME, "bola");
			bola.setPropertyValue(MyWorldEntityFactory.COLOR, "blanco");
			LookData.getInstance().getDataHandler().addEntity(bola);

			// Creamos el bandern
			banderin = new EntityData("banderin");
			banderin.setLocation(20, 3, 4);
			banderin.setPropertyValue(MyWorldEntityFactory.NAME, "banderin");
			banderin.setPropertyValue(MyWorldEntityFactory.COLOR, "verde");
			LookData.getInstance().getDataHandler().addEntity(banderin);

			// Actualizamos BD
			LookData.getInstance().updateData();
			
		// Seguimiento del juego
		}else{
			
			golpes = bundle.getInt("golpes");
			tv_golpes.setText("Nmero de golpes: " + golpes);
			
			// Recuperamos posiciones
			float[] posicion_bola = (float[]) bundle.get("posicion_bola");
			float x1 = posicion_bola[0];
			float y1 = posicion_bola[1];
			float z1 = posicion_bola[2];
			
			// Recuperamos la bola y el bandern
			bola = LookData.getInstance().getDataHandler().getLista().get(0);
			banderin = LookData.getInstance().getDataHandler().getLista().get(1);
			
			// Actualizamos la posicin de la bola
			LookData.getInstance().getDataHandler().updatePosition(bola, x1, y1, z1);
			
			//Introducimos en la BD
			LookData.getInstance().getDataHandler().addEntity(bola);
			LookData.getInstance().getDataHandler().addEntity(banderin);
			
			// Actualizamos BD
			LookData.getInstance().updateData();
			
			//Si hemos dado ms de 10 golpes o hemos metido la bola -> FIN
			if(golpes > 9 || Operaciones.estaDentro(bola, banderin)){
				Integer val = 0;
				if(golpes > 9){
					val = 0;
				}
				if(Operaciones.estaDentro(bola, banderin)){
					val = 1;
				}
				Bundle b = new Bundle();
				b.putInt("fin", val);
				b.putInt("golpes", golpes);
				
				//Creamos el Intent
	        	Intent intent = new Intent(PrincipalAct.this, FinalAct.class);
	        	
	        	//Aadimos la informacin al intent
	            intent.putExtras(b);
	        	
	        	//Iniciamos la nueva actividad
	            startActivity(intent);
			}
			
		}
		
		//Botn golpear
		btn_golpear.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				//Creamos el Intent
	        	Intent intent = new Intent(PrincipalAct.this, SensoresAct.class);
	        	
	        	//Creamos la informacin a pasar entre actividades
	            float[] posicion_bola = new float[3];
	            posicion_bola[0] = bola.getLocation().x;
	            posicion_bola[1] = bola.getLocation().y;
	            posicion_bola[2] = bola.getLocation().z;
	            
	            //Aumentamos nmero de golpes
	            golpes = golpes + 1;
	            
	        	Bundle b = new Bundle();
	            b.putFloatArray("posicion_bola", posicion_bola);
	            b.putInt("golpes", golpes);

	            //Aadimos la informacin al intent
	            intent.putExtras(b);
	        	
	        	//Iniciamos la nueva actividad
	            startActivity(intent);
				
			}
		});

	}

	private void addHud() {
		ViewGroup v = getHudContainer(); 
		v.addView(LookARUtil.getView(R.layout.principal_act, null));
	}
	
	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {

	    if(event.getAction() == KeyEvent.ACTION_DOWN)
	    {
	    	
	    }
	    return false;
	}
	
}